//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum -0.1
#property indicator_maximum  1.1
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern int    RsiPeriod  = 14;
extern int    RsiPrice   = 0;
extern int    RsiDepth   = 3;
extern bool   RsiFast    = false;
extern double LevelUp    = 0.85;
extern double LevelDown  = 0.15;

//
//
//
//
//

double rsi[];
double rsiDa[];
double rsiDb[];
double slope[];

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,rsi);
   SetIndexBuffer(1,rsiDa);
   SetIndexBuffer(2,rsiDb);
   SetIndexBuffer(3,slope);
         SetLevelValue(0,LevelUp);
         SetLevelValue(1,LevelDown);
      RsiDepth = MathMax(MathMin(RsiDepth,5),2);
   IndicatorShortName("Composite RSI ("+RsiPeriod+","+RsiDepth+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars - counted_bars,Bars-1);
         if (slope[limit]==-1) CleanPoint(limit,rsiDa,rsiDb);

   //
   //
   //
   //
   //
   
      for(int i = limit; i >= 0 ; i--)
      {
         rsi[i]   = iT3Rsi(iMA(NULL,0,1,0,MODE_SMA,RsiPrice,i),RsiPeriod,RsiDepth,RsiFast,i);
         rsiDa[i] = EMPTY_VALUE;
         rsiDb[i] = EMPTY_VALUE;
         slope[i] = slope[i+1];
            if (rsi[i] > rsi[i+1]) slope[i] =  1;
            if (rsi[i] < rsi[i+1]) slope[i] = -1;
            if (slope[i]==-1) PlotPoint(i,rsiDa,rsiDb,rsi);
      }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workCompRsi[][6];

//
//
//
//
//

double iT3Rsi(double price, double period, int depth, bool fast, int i, int instanceNo=0)
{
   if (ArrayRange(workCompRsi,0) !=Bars) ArrayResize(workCompRsi,Bars);
   if (!fast)
        double alpha = 2.0/(1.0 + period);
   else        alpha = 2.0/(2.0 + (period-1.0)/2.0);
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workCompRsi[r][0+buffer] = price;
         workCompRsi[r][1+buffer] = price;
         workCompRsi[r][2+buffer] = price;
         workCompRsi[r][3+buffer] = price;
         workCompRsi[r][4+buffer] = price;
         workCompRsi[r][5+buffer] = price;
      }
   else
      {
         workCompRsi[r][0+buffer] = workCompRsi[r-1][0+buffer]+alpha*(price                   -workCompRsi[r-1][0+buffer]);
         workCompRsi[r][1+buffer] = workCompRsi[r-1][1+buffer]+alpha*(workCompRsi[r][0+buffer]-workCompRsi[r-1][1+buffer]);
         workCompRsi[r][2+buffer] = workCompRsi[r-1][2+buffer]+alpha*(workCompRsi[r][1+buffer]-workCompRsi[r-1][2+buffer]);
         workCompRsi[r][3+buffer] = workCompRsi[r-1][3+buffer]+alpha*(workCompRsi[r][2+buffer]-workCompRsi[r-1][3+buffer]);
         workCompRsi[r][4+buffer] = workCompRsi[r-1][4+buffer]+alpha*(workCompRsi[r][3+buffer]-workCompRsi[r-1][4+buffer]);
         workCompRsi[r][5+buffer] = workCompRsi[r-1][5+buffer]+alpha*(workCompRsi[r][4+buffer]-workCompRsi[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //

   double CU  = 0.00;
   double CD  = 0.00;
   double rsi = 0;
   while (true)
   {
      if (workCompRsi[r][buffer+0] >= workCompRsi[r][buffer+1])
      			CU =      workCompRsi[r][buffer+0] - workCompRsi[r][buffer+1];
      else	   CD =      workCompRsi[r][buffer+1] - workCompRsi[r][buffer+0];
      if (workCompRsi[r][buffer+1] >= workCompRsi[r][buffer+2])
      			CU = CU + workCompRsi[r][buffer+1] - workCompRsi[r][buffer+2];
      else	   CD = CD + workCompRsi[r][buffer+2] - workCompRsi[r][buffer+1];
      if (depth<3) break;
      if (workCompRsi[r][buffer+2] >= workCompRsi[r][buffer+3])
        		   CU = CU + workCompRsi[r][buffer+2] - workCompRsi[r][buffer+3];
      else	   CD = CD + workCompRsi[r][buffer+3] - workCompRsi[r][buffer+2];
      if (depth<4) break;
      if (workCompRsi[r][buffer+3] >= workCompRsi[r][buffer+4])
        		   CU = CU + workCompRsi[r][buffer+3] - workCompRsi[r][buffer+4];
       else	   CD = CD + workCompRsi[r][buffer+4] - workCompRsi[r][buffer+3];
       if (depth<5) break;
       if (workCompRsi[r][buffer+4] >= workCompRsi[r][buffer+5])
        		   CU = CU + workCompRsi[r][buffer+4] - workCompRsi[r][buffer+5];
       else	   CD = CD + workCompRsi[r][buffer+5] - workCompRsi[r][buffer+4];
        break;
   }            
   if (CU + CD != 0) rsi = CU / (CU + CD); return(rsi);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}